#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "global.h"
#include "io.h"
#include "anim.h"
#include "light.h"
#include "rpn.h"
#include "body.h"

static double *constr_global_pointer[6]={ &gl.x, &gl.y, &gl.z,
		&gl.phix, &gl.phiy, &gl.phix };

double RPN_Evaluate(RPN *,double *,double **,double *,vect *,int *,int,int);
void Plot_Font(constrglobal *,int);

void Set_Dir(vect *vrv,double *rx,double *ry,double *rz,double *phi)
{
  double srv;

  srv=sqrt(vrv->v[0]*vrv->v[0]+vrv->v[1]*vrv->v[1]+vrv->v[2]*vrv->v[2]);
  if (srv>0.0) {
    vrv->v[0]/=srv;
    vrv->v[1]/=srv;
  }
  *rx=vrv->v[1];
  *ry=-vrv->v[0];
  *rz=0.0;
  if ((fabs(*rx)+fabs(*ry))==0.0) {
    *phi=0.0;
    *rx=1.0;
  } else {
    *phi=-asin(sqrt(vrv->v[0]*vrv->v[0]+vrv->v[1]*vrv->v[1]));
  }
  if (vrv->v[2]<0.0) *phi=M_PI-(*phi);
}

int DetArray(int a,int b,int n,int *Ne,int *Np,int *atype,int *ntype)
{
  int N,c;
  double srv;
  
  N=n-1;
  if (cg[b].p[N]!=NULL) {
    RPN_Evaluate(cg[b].p[N],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,0,a);
    *ntype=*atype=(int)srv;
    if (*atype<0) {
      *ntype=-1;
      *atype*=-1;
    }
  } else {
    *ntype=*atype=-1;
  }
  N--;
  if ((cg[b].p[N]==NULL) || (cg[b].arrayvar[N]==0)) *Ne=0;
  else *Ne=1;
  *Np=0;
  while (N>0) {
    N--;
    if ((cg[b].p[N]!=NULL) && (cg[b].arrayvar[N])) *Np=1;
  }
  /* not of this type */
  if ((*atype>0) && (*atype!=body[a].obj+1)) return(2);
  N=n-2; /* expr */
  if (!(*Ne)) {
    RPN_Evaluate(cg[b].p[N],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,0,a);
    if (srv<=0.0) return(1);
  }
  if ((*Ne) && (!(*Np))) {
    for (c=0;c<bg.body_num;c++) {
      if ((*ntype<0) || (*ntype==body[c].obj+1)) {
        RPN_Evaluate(cg[b].p[N],lb.params,bg.rpnglobpoint,
				NULL,NULL,NULL,2,c);
      }
    }
    RPN_Evaluate(cg[b].p[N],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,0,a);
    if (srv<=0.0) return(1);
  }
  return(0);
}

void SetTrans(void)
{
  int a,b,type;
  double srv;

  a=0;
  for (b=0;b<bg.cgnum;b++) {
    if (cg[b].type==10) {
      if (cg[b].p[0]==NULL) continue;
      a=1;
    }
  }
  if (!a) return;
  for (a=0;a<bg.body_num;a++) {
    body[a].blend=body[a].appearance&BA_Blend;
  }
  for (b=0;b<bg.cgnum;b++) {
    if (cg[b].type==10) {
      if (cg[b].p[0]==NULL) continue;
      type=-1;
      if (cg[b].p[2]!=NULL) {
        RPN_Evaluate(cg[b].p[2],body[0].params,bg.rpnglobpoint,
				&srv,NULL,NULL,0,0);
        type=(int)srv;
      }
      for (a=0;a<bg.body_num;a++) {
	if ((body[a].obj+1!=type) && (type!=-1)) continue;
	srv=1.0;
	if (cg[b].p[1]!=NULL) {
	  RPN_Evaluate(cg[b].p[1],body[a].params,bg.rpnglobpoint,
				&srv,NULL,NULL,0,a);
	}
	if (srv>0.0) {
	  RPN_Evaluate(cg[b].p[0],body[a].params,bg.rpnglobpoint,
				&srv,NULL,NULL,0,a);
	  body[a].blend=(srv>0.0);
	}
      }
    }
  }
}

void SetGlobalVar(int i,vect *vrv,int sv)
{
  if (i<6) {
    (*constr_global_pointer[i])=vrv->v[0];
  } else if (sv) {
    if (i==6) {
      gl.x=vrv->v[0];
      gl.y=vrv->v[1];
      gl.z=vrv->v[2];
    } else {
      gl.phix=vrv->v[0];
      gl.phiy=vrv->v[1];
      gl.phiz=vrv->v[2];
    }
  }
}

void SetVar(void)
{
  int a,b,n,atype,ntype,cycle,vari,sv,change;
  double srv;
  vect vrv;

  if ((anim.objectread==0) && (animation.framerepeat<=1)) return;
  anim.objectread=0;
  for (b=0;b<bg.cgnum;b++) {
    if (cg[b].type==9) {
      /* Var */
      if ((cg[b].p[0]==NULL) || (cg[b].p[1]==NULL)) continue;
      if (!cg[b].arrayvar[0]) {
	if (cg[b].p[0]->type==RpnT_GlobalVar) {
	  vari=-1-cg[b].p[0]->ival;
	} else {
	  RPN_Evaluate(cg[b].p[0],body[0].params,bg.rpnglobpoint,
				&srv,NULL,NULL,0,0);
	  vari=(int)srv;
	  if ((vari<0) || (vari>=cvg.var_num)) continue;
	}
      }
      if (cg[b].p[3]!=NULL) {
        RPN_Evaluate(cg[b].p[3],body[0].params,bg.rpnglobpoint,
				&srv,NULL,NULL,0,0);
        ntype=atype=(int)srv;
        if (atype<0) {
          ntype=-1;
          atype*=-1;
        }
      } else {
        ntype=atype=-1;
      }
      if (cg[b].p[2]==NULL) cycle=0;
      else if (cg[b].arrayvar[2]==0) cycle=1;
      else cycle=2;
      if (cg[b].arrayvar[1]!=0) cycle=2;
      if (vari<0) cycle=min(1,cycle);
      if (cycle==0) {
	RPN_Evaluate(cg[b].p[1],body[0].params,bg.rpnglobpoint,
				NULL,&vrv,&sv,0,0);
	if (vari>=0) {
	  cvg.var[vari].v[0]=vrv.v[0];
	  cvg.var[vari].v[1]=vrv.v[1];
	  cvg.var[vari].v[2]=vrv.v[2];
	  cvg.vc[vari]=sv;
	} else {
	  SetGlobalVar(-1-vari,&vrv,sv);
	}
      } else if (cycle==1) {
	if (vari>=0) {
	  change=0;
	  for (a=0;a<bg.body_num;a++) {
	    if ((atype>0) && (atype!=body[a].obj+1)) continue;
	    RPN_Evaluate(cg[b].p[0],body[a].params,bg.rpnglobpoint,
				&srv,NULL,NULL,4,a);
	    if (vari!=(int)srv) change=1;
	    vari=(int)srv;
	    if ((vari>=0) && (vari<cvg.var_num)) {
	      RPN_Evaluate(cg[b].p[2],body[a].params,bg.rpnglobpoint,
				&srv,NULL,NULL,0,a);
	      if (srv>0.0) {
		RPN_Evaluate(cg[b].p[1],body[a].params,bg.rpnglobpoint,
				NULL,&vrv,&sv,3,a);
		cvg.var[vari].v[0]=vrv.v[0];
		cvg.var[vari].v[1]=vrv.v[1];
		cvg.var[vari].v[2]=vrv.v[2];
		cvg.vc[vari]=sv;
	      }
	    }
	  }
	  if (!change) {
	    RPN_Evaluate(cg[b].p[1],body[0].params,bg.rpnglobpoint,
				NULL,&vrv,&sv,4,0);
	    cvg.var[vari].v[0]=vrv.v[0];
	    cvg.var[vari].v[1]=vrv.v[1];
	    cvg.var[vari].v[2]=vrv.v[2];
	    cvg.vc[vari]=sv;
	  }
	} else {
	  change=0;
	  for (a=0;a<bg.body_num;a++) {
	    if ((atype>0) && (atype!=body[a].obj+1)) continue;
	    RPN_Evaluate(cg[b].p[2],body[a].params,bg.rpnglobpoint,
				&srv,NULL,NULL,0,a);
	    if (srv>0.0) {
	      RPN_Evaluate(cg[b].p[1],body[a].params,bg.rpnglobpoint,
				NULL,&vrv,&sv,3,a);
	      SetGlobalVar(-1-vari,&vrv,sv);
	    }
	  }
	  if (!change) {
	    RPN_Evaluate(cg[b].p[1],body[0].params,bg.rpnglobpoint,
				NULL,&vrv,&sv,4,0);
	    SetGlobalVar(-1-vari,&vrv,sv);
	  }
	}
      } else { /* cycle===2 */
        for (a=0;a<bg.body_num;a++) {
          if ((atype>0) && (atype!=body[a].obj+1)) continue;
          for (n=0;n<bg.body_num;n++) {
            if ((ntype>0) && (ntype!=body[n].obj+1)) continue;
            RPN_Evaluate(cg[b].p[2],body[a].params,bg.rpnglobpoint,
				&srv,NULL,NULL,0,n);
            if (srv>0.0) {
              RPN_Evaluate(cg[b].p[1],body[a].params,bg.rpnglobpoint,
				NULL,&vrv,&sv,3,n);
            }
          }
          if (cg[b].arrayvar[0]!=0) {
            RPN_Evaluate(cg[b].p[0],body[a].params,bg.rpnglobpoint,
				&srv,NULL,NULL,4,a);
            vari=(int)srv;
            if ((vari>=0) && (vari<cvg.var_num)) {
              RPN_Evaluate(cg[b].p[1],body[a].params,bg.rpnglobpoint,
				NULL,&vrv,&sv,4,a);
              cvg.var[vari].v[0]=vrv.v[0];
              cvg.var[vari].v[1]=vrv.v[1];
              cvg.var[vari].v[2]=vrv.v[2];
              cvg.vc[vari]=sv;
            }
          }
        }
        if (cg[b].arrayvar[0]==0) {
          RPN_Evaluate(cg[b].p[1],body[a].params,bg.rpnglobpoint,
				NULL,&vrv,&sv,4,0);
          cvg.var[vari].v[0]=vrv.v[0];
          cvg.var[vari].v[1]=vrv.v[1];
          cvg.var[vari].v[2]=vrv.v[2];
          cvg.vc[vari]=sv;
        }
      }
    }
  }
}

void CheckFont(int a)
{
  int b;

  if (a) {
    for (b=0;b<bg.cgnum;b++) {
      if (cg[b].type==-11) {
	Plot_Font(&cg[b],a);
      }
    }
  } else {
    for (b=0;b<bg.cgnum;b++) {
      if (cg[b].type==11) {
	Plot_Font(&cg[b],a);
      }
    }
  }
}

int Constraint(int a,int b,int mode)
{
  int c,d,atype,ntype,Ne,Np;
  int sv;
  double srv,srv1;
  double px,py,pz,cpy,spy;
  vect vrv;

  switch (cg[b].type) {
    case 0:     /* Arrow */
      if (DetArray(a,b,5,&Ne,&Np,&atype,&ntype)) return(0);
      if (Np) {
        for (c=0;c<bg.body_num;c++) {
          if ((ntype<0) || (ntype==body[c].obj+1)) {
            if (Ne) RPN_Evaluate(cg[b].p[3],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,2,c);
            else srv=1.0;
            if (srv>0) {
	      RPN_Evaluate(cg[b].p[2],lb.params,bg.rpnglobpoint,
				NULL,NULL,NULL,2,c);
	      RPN_Evaluate(cg[b].p[1],lb.params,bg.rpnglobpoint,
				NULL,NULL,NULL,2,c);
              RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				NULL,NULL,NULL,2,c);
            }
          }
        }
      }
      RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				NULL,&vrv,&sv,0,a);
      if (sv) {
        lb.type=BT_Arrow;
        Set_Dir(&vrv,&lb.rx,&lb.ry,&lb.rz,&lb.phi);
        if (cg[b].p[1]!=NULL) {
          RPN_Evaluate(cg[b].p[1],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,0,a);
          lb.sx=srv;
        }
        if (cg[b].p[2]!=NULL) {
          RPN_Evaluate(cg[b].p[2],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,0,a);
          lb.sz=srv;
        } else {
          lb.sz=lb.sx*0.01;
        }
      }
      break;
    case 1:     /* Color */
      if (DetArray(a,b,6,&Ne,&Np,&atype,&ntype)) return(0);
      if (Np) {
        for (c=0;c<bg.body_num;c++) {
          if ((ntype<0) || (ntype==body[c].obj+1)) {
            if (Ne) RPN_Evaluate(cg[b].p[4],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,2,c);
            else srv=1.0;
            if (srv>0) {
              RPN_Evaluate(cg[b].p[3],lb.params,bg.rpnglobpoint,
				NULL,NULL,NULL,2,c);
              RPN_Evaluate(cg[b].p[2],lb.params,bg.rpnglobpoint,
				NULL,NULL,NULL,2,c);
              RPN_Evaluate(cg[b].p[1],lb.params,bg.rpnglobpoint,
				NULL,NULL,NULL,2,c);
              RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				NULL,NULL,NULL,2,c);
            }
          }
        }
      }
      if (cg[b].p[3]!=NULL) {
        RPN_Evaluate(cg[b].p[3],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,mode,0);
        lb.color[3]=srv;
      }
      RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				&srv,&vrv,&sv,mode,0);
      if (sv) {
	lb.color[0]=vrv.v[0];
	lb.color[1]=vrv.v[1];
	lb.color[2]=vrv.v[2];
      } else {
	lb.color[0]=srv;
	if (cg[b].p[2]!=NULL) {
	  RPN_Evaluate(cg[b].p[2],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,mode,0);
	  lb.color[2]=srv;
	}
	if (cg[b].p[1]!=NULL) {
	  RPN_Evaluate(cg[b].p[1],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,mode,0);
	  lb.color[1]=srv;
	}
      }
      break;
    case 2:     /* Cut */
      if (DetArray(a,b,4,&Ne,&Np,&atype,&ntype)) return(0);
      if (Np) {
        for (c=0;c<bg.body_num;c++) {
          if ((ntype<0) || (ntype==body[c].obj+1)) {
            if (Ne) RPN_Evaluate(cg[b].p[2],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,2,c);
            else srv=1.0;
            if (srv>0) {
              RPN_Evaluate(cg[b].p[1],lb.params,bg.rpnglobpoint,
				NULL,NULL,NULL,2,c);
              RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				NULL,NULL,NULL,2,c);
            }
          }
        }
      }
      RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,mode,0);
      RPN_Evaluate(cg[b].p[1],lb.params,bg.rpnglobpoint,
				&srv1,NULL,NULL,mode,0);
      px=gl.phix/RP;
      py=gl.phiy/RP;
      pz=gl.phiz/RP;
      cpy=cos(py);
      spy=sin(py);
      if (fabs(-cos(px)*(lb.x*spy+lb.y*cpy)+
                sin(px)*( (lb.x*cpy-lb.y*spy)*sin(pz)+
                lb.z*cos(pz))+srv) > fabs(srv1)) return(1);
      break;
    case 3:     /* Dir */
      if (DetArray(a,b,3,&Ne,&Np,&atype,&ntype)) return(0);
      if (Np) {
        for (c=0;c<bg.body_num;c++) {
          if ((ntype<0) || (ntype==body[c].obj+1)) {
            if (Ne) RPN_Evaluate(cg[b].p[1],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,2,c);
            else srv=1.0;
            if (srv>0) {
              RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				NULL,NULL,NULL,2,c);
            }
          }
        }
      }
      RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				NULL,&vrv,&sv,mode,0);
      if (sv) {
        Set_Dir(&vrv,&lb.rx,&lb.ry,&lb.rz,&lb.phi);
        lb.params[CEF_SUBPARNUM*3]=lb.rx;
        lb.params[CEF_SUBPARNUM*3+1]=lb.ry;
        lb.params[CEF_SUBPARNUM*3+2]=lb.rz;
        lb.params[CEF_SUBPARNUM*3+3]=lb.phi;
      }
      break;
    case 4:     /* New */
      /* do not recreate twice */
      if ((bg.new_num<=bg.body_num) || (a>=bg.body_num)) break;
      if ((cg[b].p[0]==NULL) || (cg[b].p[2]==NULL)) break;
      srv=2.0;
      if ((cg[b].p[1]==NULL) && ((a!=0) || (mode!=0))) break;
      Np=cg[b].arrayvar[1]+cg[b].arrayvar[2]+cg[b].arrayvar[3]+
						cg[b].arrayvar[4];
      Np=(Np ? bg.body_num : 1);
      for (c=0;c<Np;c++) {
	if (cg[b].p[1]!=NULL) 
	      RPN_Evaluate(cg[b].p[1],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,mode,c);
	if (srv>0.0) {
	  bg.new_num--;
	  RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,mode,c);
	  body[bg.new_num].type=(int)srv;
	  RPN_Evaluate(cg[b].p[2],lb.params,bg.rpnglobpoint,
				NULL,&vrv,NULL,mode,c);
	  body[bg.new_num].sx=vrv.v[0];
	  body[bg.new_num].sy=vrv.v[1];
	  body[bg.new_num].sz=vrv.v[2];
	  if (cg[b].p[3]!=NULL) {
	    RPN_Evaluate(cg[b].p[3],lb.params,bg.rpnglobpoint,
				NULL,&vrv,NULL,mode,c);
	    body[bg.new_num].x=vrv.v[0];
	    body[bg.new_num].y=vrv.v[1];
	    body[bg.new_num].z=vrv.v[2];
	  } else {
	    body[bg.new_num].x=0.0;
	    body[bg.new_num].y=0.0;
	    body[bg.new_num].z=0.0;
	  }
	  if (cg[b].p[4]!=NULL) {
	    RPN_Evaluate(cg[b].p[4],lb.params,bg.rpnglobpoint,
				NULL,&vrv,NULL,mode,c);
	    Set_Dir(&vrv,&body[bg.new_num].rx,&body[bg.new_num].ry,
			&body[bg.new_num].rz,&body[bg.new_num].phi);
	  } else {
	    body[bg.new_num].rx=1.0;
	    body[bg.new_num].ry=0.0;
	    body[bg.new_num].rz=0.0;
	    body[bg.new_num].phi=0.0;
	  }
	  for (d=bg.new_num+1;d<body_alloc;d++) {
	    if ((body[d].type==body[bg.new_num].type) &&
		(body[d].sx==body[bg.new_num].sx) &&
		(body[d].sy==body[bg.new_num].sy) &&
		(body[d].sz==body[bg.new_num].sz) &&
		(body[d].x==body[bg.new_num].x) &&
		(body[d].y==body[bg.new_num].y) &&
		(body[d].z==body[bg.new_num].z) &&
		(body[d].rx==body[bg.new_num].rx) &&
		(body[d].ry==body[bg.new_num].ry) &&
		(body[d].rz==body[bg.new_num].rz) &&
		(body[d].phi==body[bg.new_num].phi)) break;
	  }
	  if (d<body_alloc) {
	    bg.new_num++;
	  } else {
	    if (cg[b].p[5]!=NULL) {
	      RPN_Evaluate(cg[b].p[5],lb.params,bg.rpnglobpoint,
				NULL,&vrv,NULL,mode,c);
	      body[bg.new_num].color[0]=vrv.v[0];
	      body[bg.new_num].color[1]=vrv.v[1];
	      body[bg.new_num].color[2]=vrv.v[2];
	    } else {
	      body[bg.new_num].color[0]=1.0;
	      body[bg.new_num].color[1]=1.0;
	      body[bg.new_num].color[2]=1.0;
	    }
	    body[bg.new_num].color[3]=1.0;
	    body[bg.new_num].tex=0;
	    body[bg.new_num].blend=0;
	    body[bg.new_num].obj=bg.obj_num;
	  }
	}
      }
      break;
    case 5:     /* Position */
      if (DetArray(a,b,3,&Ne,&Np,&atype,&ntype)) return(0);
      if (Np) {
        for (c=0;c<bg.body_num;c++) {
          if ((ntype<0) || (ntype==body[c].obj+1)) {
            if (Ne) RPN_Evaluate(cg[b].p[1],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,2,c);
            else srv=1.0;
            if (srv>0) {
              RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				NULL,NULL,NULL,2,c);
            }
          }
        }
      }
      RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				NULL,&vrv,&sv,mode,0);
      if (sv) {
        lb.params[CEF_SUBPARNUM*2]=lb.x=vrv.v[0];
        lb.params[CEF_SUBPARNUM*2+1]=lb.y=vrv.v[1];
        lb.params[CEF_SUBPARNUM*2+2]=lb.z=vrv.v[2];
      }
      break;
    case 6:     /* Texture */
      if (DetArray(a,b,3,&Ne,&Np,&atype,&ntype)) return(0);
      if (Np) {
        for (c=0;c<bg.body_num;c++) {
          if ((ntype<0) || (ntype==body[c].obj+1)) {
            if (Ne) RPN_Evaluate(cg[b].p[1],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,2,c);
            else srv=1.0;
            if (srv>0) {
              RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				NULL,NULL,NULL,2,c);
            }
          }
        }
      }
      RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,0,a);
      lb.tex=(int)srv;
      break;
    case 7:     /* Show */
      if (DetArray(a,b,2,&Ne,&Np,&atype,&ntype)==1) return(1);
      break;
    case 8:     /* Size */
      if (DetArray(a,b,3,&Ne,&Np,&atype,&ntype)) return(0);
      if (Np) {
        for (c=0;c<bg.body_num;c++) {
          if ((ntype<0) || (ntype==body[c].obj+1)) {
            if (Ne) RPN_Evaluate(cg[b].p[1],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,2,c);
            else srv=1.0;
            if (srv>0) {
              RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				NULL,NULL,NULL,2,c);
            }
          }
        }
      }
      RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				NULL,&vrv,&sv,0,a);
      if (sv) {
        lb.params[CEF_SUBPARNUM]=lb.sx=vrv.v[0];
        lb.params[CEF_SUBPARNUM+1]=lb.sy=vrv.v[1];
        lb.params[CEF_SUBPARNUM+1]=lb.sz=vrv.v[2];
      } else {
        lb.params[CEF_SUBPARNUM]=lb.sx=vrv.v[0];
      }
      break;
    case 12:	/* Type */
      if (DetArray(a,b,3,&Ne,&Np,&atype,&ntype)) return(0);
      if (Np) {
        for (c=0;c<bg.body_num;c++) {
          if ((ntype<0) || (ntype==body[c].obj+1)) {
            if (Ne) RPN_Evaluate(cg[b].p[1],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,2,c);
            else srv=1.0;
            if (srv>0) {
              RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				NULL,NULL,NULL,2,c);
            }
          }
        }
      }
      RPN_Evaluate(cg[b].p[0],lb.params,bg.rpnglobpoint,
				&srv,NULL,NULL,0,a);
      lb.type=(int)srv;
      break;
      break;
  }
  return(0);
}
