/* Copyright (C) 2002, by Sandor Fazekas and Janos Torok */
/* Last modified: $Date: 2003/05/12 09:22:24 $ $Revision: 1.1 $ */
#define _MOZI
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gtk/gtkgl.h>
#include <stdlib.h>
#include <stdio.h>
#include "global.h"
#include "body.h"

/* prototypes */
void FrameOff(GtkWidget *,gpointer);

const char *obj_name[8] = { "EOL", "Wall", "Ball", "Cylinder", "Disk",
			    "BallCC", "Force", "StBall" };

/* Change color value */
void Obj_Change_Color(GtkWidget *widget,gpointer data)
{
  bg.param[bg.active_obj].color[(int)data]=
  		atof(gtk_entry_get_text(GTK_ENTRY(widget)));
}

/* Redraw texture gl window */
void RedrawTex()
{
  GdkGLContext *glcontext;
  GdkGLDrawable *gldrawable;

  if (bg.param_num==0) return;
  glcontext = gtk_widget_get_gl_context (bg.texarea);
  gldrawable = gtk_widget_get_gl_drawable (bg.texarea);
  if (!gdk_gl_drawable_gl_begin (gldrawable, glcontext)) return;
  gdk_gl_drawable_swap_buffers (gldrawable);
  gdk_gl_drawable_gl_end (gldrawable);
}

/* Select texture or all */
void SetTextureType(GtkWidget *widget,gpointer data)
{
  int a;
  static GLfloat deflight[4][4] = {{ 0.0, 2.0, 3.0, 0.0},
    				    {0.4, 0.4, 0.4, 0.0},
				    {1.0, 1.0, 1.0, 1.0},
				    {0.0, 0.0, 0.0, 0.0}};
  GdkGLContext *glcontext = gtk_widget_get_gl_context (bg.texarea);
  GdkGLDrawable *gldrawable = gtk_widget_get_gl_drawable (bg.texarea);

  a=(int)data;
  bg.param[bg.active_obj].texture=a;
  if (!gdk_gl_drawable_gl_begin (gldrawable, glcontext)) return;

  /* redraw glwindow */
  glLightfv(GL_LIGHT0,GL_POSITION,deflight[0]);
  glLightfv(GL_LIGHT0,GL_AMBIENT,deflight[1]);
  glLightfv(GL_LIGHT0,GL_DIFFUSE,deflight[2]);
  glLightfv(GL_LIGHT0,GL_SPECULAR,deflight[3]);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glClearColor(gl.bg[0],gl.bg[1],gl.bg[2],gl.bg[3]);
  glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);
  if (a==0) {
    glDisable(GL_TEXTURE_2D);
    glColorMaterial(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE);
    glEnable(GL_COLOR_MATERIAL);
    glColor4f( bg.param[bg.active_obj].color[0],
    bg.param[bg.active_obj].color[1],bg.param[bg.active_obj].color[2],
    bg.param[bg.active_obj].color[3]);
  } else {
    glDisable(GL_COLOR_MATERIAL);
    glBindTexture(GL_TEXTURE_2D,gl.texture.texture[a-1]);
    glEnable(GL_TEXTURE_2D);
  }
  glLoadIdentity();
  glTranslatef(-4.5,0.0,-6.0);
  glBegin(GL_QUADS);
  glNormal3f(0.0,0.0,-1.0);
  glTexCoord2f(0.0, 1.0);
  glVertex3f(-1.5f, 1.5f, 0.0f);
  glTexCoord2f(1.0, 1.0);
  glVertex3f( 1.5f, 1.5f, 0.0f);
  glTexCoord2f(1.0, 0.0);
  glVertex3f( 1.5f,-1.5f, 0.0f);
  glTexCoord2f(0.0, 0.0);
  glVertex3f(-1.5f,-1.5f, 0.0f);
  glEnd();
  glTranslatef(4.0,0.0,0.0);
  gluSphere(gl.quad.q,1.5,gl.quad.sl,gl.quad.st);
  glTranslatef(3.5,0.0,0.0);
  glRotatef(30.0,0.0,1.0,0.0);
  gluCylinder(gl.quad.q,1.0,1.0,2.0,gl.quad.sl,gl.quad.st);

  gdk_gl_drawable_swap_buffers (gldrawable);
  gdk_gl_drawable_gl_end (gldrawable);
}

void Change_Subframe(GtkWidget *widget,gpointer data)
{
  int a;

  a=(int)data;
  gtk_frame_set_label(GTK_FRAME(bg.frame),obj_name[bg.param[a].type]);
  gtk_widget_show(bg.frame);
  bg.active_obj=a;
  if (bg.param[a].type==BT_Force) gtk_widget_show(bg.forcehbox);
  else gtk_widget_hide(bg.forcehbox);
  gtk_option_menu_set_history(
  	GTK_OPTION_MENU (bg.textmenu),bg.param[a].texture);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(bg.blend),bg.param[a].blend);
}

void CreateObjectFrame(GtkWidget *frame,GdkGLConfig *glconfig)
{
  GtkWidget *vbox;		/* vbox */
  GtkWidget **hbox;		/* hboxes */
  GtkWidget **button;		/* Buttons */
  GtkWidget **oonoff;		/* chkbutton for objects */
  GtkWidget *off;		/* switch frame off button */
  GtkWidget *fvbox;		/* vbox for frame */
  GtkWidget *hbox1;		/* hbox1 for frame */
  GtkWidget *hbox2;		/* hbox2 for frame */
  GtkWidget *hbox3;		/* hbox3 for frame */
  GtkWidget *hbox4;		/* hbox4 for frame */
  GtkWidget *svbox1;		/* vbox for hbox2 frame */
  GtkWidget *svbox2;		/* vbox for hbox2 frame */
  GtkWidget *label;		/* label widget */
  GtkWidget *menu;		/* menu widget of latter */
  GtkWidget *item;		/* item for the latter */
  GtkWidget *r,*g,*b,*a;	/* widgets for colors */
  GtkWidget *foff;		/* switch off sub frame */
  GtkWidget *forcescale;	/* scale force to maximum? */
  GtkWidget *fscale;		/* force scale */
  int i;
  char s[14];

  if (bg.param_num==0) return;
  vbox = gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame),vbox);
  hbox=(GtkWidget **) calloc(bg.param_num/3+1,sizeof(GtkWidget *));
  button=(GtkWidget **) calloc(bg.param_num,sizeof(GtkWidget *));
  oonoff=(GtkWidget **) calloc(bg.param_num,sizeof(GtkWidget *));
  for (i=0;i<bg.param_num/3+1;i++) {
    hbox[i] = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox),hbox[i],TRUE,TRUE,3);
    gtk_widget_show(hbox[i]);
  }
  for (i=0;i<bg.param_num;i++) {
    button[i]=gtk_button_new_with_label(obj_name[bg.param[i].type]);
    gtk_box_pack_start(GTK_BOX(hbox[i/3]),button[i],FALSE,FALSE,5);
    gtk_signal_connect(GTK_OBJECT (button[i]),"clicked",
            GTK_SIGNAL_FUNC(Change_Subframe),(gpointer)i);
    gtk_widget_show(button[i]);
    oonoff[i]=gtk_check_button_new();
    gtk_box_pack_start(GTK_BOX(hbox[i/3]),oonoff[i],FALSE,FALSE,5);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(oonoff[i]), TRUE);
    gtk_widget_show(oonoff[i]);
  }
  off=gtk_check_button_new_with_label("Off");
  gtk_box_pack_end(GTK_BOX(hbox[(bg.param_num-1)/3]),off,FALSE,FALSE,0);
  gtk_widget_show(off);

  /* inner frame */
  bg.active_obj=0;
  bg.frame=gtk_frame_new(obj_name[bg.param[bg.active_obj].type]);
  gtk_box_pack_start(GTK_BOX(vbox),bg.frame,TRUE,TRUE,3);
  fvbox = gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(bg.frame),fvbox);
  hbox1 = gtk_hbox_new(FALSE, 0);
  hbox2 = gtk_hbox_new(FALSE, 0);
  hbox3 = gtk_hbox_new(FALSE, 0);
  bg.forcehbox=hbox4 = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(fvbox),hbox1,TRUE,TRUE,3);
  gtk_box_pack_start(GTK_BOX(fvbox),hbox2,TRUE,TRUE,3);
  gtk_box_pack_start(GTK_BOX(fvbox),hbox3,TRUE,TRUE,3);
  gtk_box_pack_start(GTK_BOX(fvbox),hbox4,TRUE,TRUE,3);
  label=gtk_label_new("Texture:");
  gtk_box_pack_start(GTK_BOX(hbox1),label,FALSE,FALSE,5);
  gtk_widget_show(label);
  bg.textmenu=gtk_option_menu_new();
  menu=gtk_menu_new();
  for (i=0;i<=gl.texture.num;i++) {
    if (i>0) sprintf(s,"%d",i-1);
    else sprintf(s,"No");
    item=gtk_menu_item_new_with_label(s);
    gtk_signal_connect(GTK_OBJECT(item),"activate",
	GTK_SIGNAL_FUNC(SetTextureType),(gpointer) i);
    gtk_widget_show(item);
    gtk_menu_append (GTK_MENU (menu), item);
  }
  gtk_option_menu_set_menu (GTK_OPTION_MENU (bg.textmenu), menu);
  gtk_widget_show(menu);
  gtk_widget_show(bg.textmenu);
  gtk_box_pack_start(GTK_BOX(hbox1),bg.textmenu,FALSE,FALSE,5);
  bg.texarea = gtk_drawing_area_new();
  gtk_widget_set_size_request (bg.texarea, 92, 32);
  gtk_widget_set_usize(bg.texarea, 92, 32);
  gtk_widget_set_gl_capability(bg.texarea,glconfig,NULL,TRUE,GDK_GL_RGBA_TYPE);
  gtk_box_pack_start(GTK_BOX(hbox1),bg.texarea,FALSE,FALSE,10);
  gtk_widget_show(bg.texarea);
  label=gtk_label_new("Color:");
  gtk_box_pack_end(GTK_BOX(hbox1),label,FALSE,FALSE,5);
  gtk_widget_show(label);

  label=gtk_label_new("Red:");
  gtk_box_pack_start(GTK_BOX(hbox2),label,FALSE,FALSE,3);
  gtk_widget_show(label);
  r=gtk_entry_new_with_max_length(4);
  gtk_widget_set_usize(r,36,0);
  sprintf(s,"%.2lf",bg.param[bg.active_obj].color[0]);
  gtk_entry_set_text(GTK_ENTRY(r), s);
  gtk_box_pack_start(GTK_BOX(hbox2), r, FALSE, FALSE, 3);
  gtk_widget_show(r);
  label=gtk_label_new("Green:");
  gtk_box_pack_start(GTK_BOX(hbox2),label,FALSE,FALSE,3);
  gtk_widget_show(label);
  g=gtk_entry_new_with_max_length(4);
  gtk_widget_set_usize(g,36,0);
  sprintf(s,"%.2lf",bg.param[bg.active_obj].color[1]);
  gtk_entry_set_text(GTK_ENTRY(g), s);
  gtk_box_pack_start(GTK_BOX(hbox2), g, FALSE, FALSE, 3);
  gtk_widget_show(g);
  label=gtk_label_new("Blue:");
  gtk_box_pack_start(GTK_BOX(hbox2),label,FALSE,FALSE,3);
  gtk_widget_show(label);
  b=gtk_entry_new_with_max_length(4);
  gtk_widget_set_usize(b,36,0);
  sprintf(s,"%.2lf",bg.param[bg.active_obj].color[2]);
  gtk_entry_set_text(GTK_ENTRY(b), s);
  gtk_box_pack_start(GTK_BOX(hbox2), b, FALSE, FALSE, 3);
  gtk_widget_show(b);
  label=gtk_label_new("Alpha:");
  gtk_box_pack_start(GTK_BOX(hbox2),label,FALSE,FALSE,3);
  gtk_widget_show(label);
  a=gtk_entry_new_with_max_length(4);
  gtk_widget_set_usize(a,36,0);
  sprintf(s,"%.2lf",bg.param[bg.active_obj].color[3]);
  gtk_entry_set_text(GTK_ENTRY(a), s);
  gtk_box_pack_start(GTK_BOX(hbox2), a, FALSE, FALSE, 3);
  gtk_widget_show(a);

  foff=gtk_check_button_new_with_label("Frame off");
  gtk_box_pack_end(GTK_BOX(hbox3),foff,FALSE,FALSE,0);
  gtk_widget_show(foff);
  bg.blend=gtk_check_button_new_with_label("Transparent");
  gtk_box_pack_start(GTK_BOX(hbox3), bg.blend, FALSE, FALSE, 3);
  gtk_widget_show(bg.blend);

  forcescale=gtk_check_button_new_with_label("Rescale force to max");
  gtk_box_pack_start(GTK_BOX(hbox4), forcescale, FALSE, FALSE, 3);
  gtk_widget_show(forcescale);
  fscale=gtk_entry_new_with_max_length(6);
  gtk_widget_set_usize(fscale,60,0);
  bg.fscale=1000.0;
  bg.fsize=0.001;
  sprintf(s,"%.2lf",bg.fscale);
  gtk_entry_set_text(GTK_ENTRY(fscale), s);
  gtk_box_pack_end(GTK_BOX(hbox4), fscale, FALSE, FALSE, 3);
  gtk_widget_show(fscale);
  label=gtk_label_new("Scale:");
  gtk_box_pack_end(GTK_BOX(hbox4),label,FALSE,FALSE,3);
  gtk_widget_show(label);
  /* this applies only to force shown only if object is force */
  Change_Subframe((GtkWidget *)NULL,(gpointer)bg.active_obj);

  gtk_widget_show(hbox3);
  gtk_widget_show(hbox2);
  gtk_widget_show(hbox1);
  gtk_widget_show(fvbox);
  gtk_widget_show(bg.frame);

  /* Set up gl box */
  {
    GdkGLContext *glcontext = gtk_widget_get_gl_context (bg.texarea);
    GdkGLDrawable *gldrawable = gtk_widget_get_gl_drawable (bg.texarea);
    if (gdk_gl_drawable_gl_begin (gldrawable, glcontext)) {
      glClearColor(gl.bg[0],gl.bg[1],gl.bg[2],gl.bg[3]);
      glClearDepth(1.0);
      glDepthFunc(GL_LESS);
      glEnable(GL_DEPTH_TEST);
      glShadeModel(GL_SMOOTH);
      glViewport(0,0,92,32);
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
      gluPerspective(gl.persp.angle,2.875,gl.persp.zNear,gl.persp.zFar);
      glMatrixMode(GL_MODELVIEW);
      glBlendFunc(GL_SRC_ALPHA,GL_ONE);

/*      glGenTextures(gl.texture.num, gl.texture.texture);*/
      for (i=0;i<gl.texture.num;i++) {
	glBindTexture(GL_TEXTURE_2D, gl.texture.texture[i]);
	glTexImage2D(GL_TEXTURE_2D, 0, 3, gl.texture.detail[i].width,
			gl.texture.detail[i].height, 0,
			GL_RGB, GL_UNSIGNED_BYTE, gl.texture.detail[i].data);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
      }
      gdk_gl_drawable_gl_end (gldrawable);
      SetTextureType((GtkWidget *)NULL,(gpointer) bg.active_obj+1);
    }
  }

  gtk_signal_connect (GTK_OBJECT (r), "activate",
     		GTK_SIGNAL_FUNC(Obj_Change_Color),(gpointer)0);
  gtk_signal_connect (GTK_OBJECT (g), "activate",
     		GTK_SIGNAL_FUNC(Obj_Change_Color),(gpointer)1);
  gtk_signal_connect (GTK_OBJECT (b), "activate",
     		GTK_SIGNAL_FUNC(Obj_Change_Color),(gpointer)2);
  gtk_signal_connect (GTK_OBJECT (a), "activate",
     		GTK_SIGNAL_FUNC(Obj_Change_Color),(gpointer)3);
  gtk_signal_connect (GTK_OBJECT (off), "toggled",
		GTK_SIGNAL_FUNC (FrameOff), (gpointer)frame);
  gtk_signal_connect (GTK_OBJECT (foff), "toggled",
		GTK_SIGNAL_FUNC (FrameOff), (gpointer)bg.frame);
  gtk_signal_connect(GTK_OBJECT(bg.texarea), "expose_event",
		GTK_SIGNAL_FUNC(RedrawTex), NULL);

  gtk_widget_show(vbox);
}
